/* ***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1/GPL 2.0/LGPL 2.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is Quick Locale Switcher code.

The Initial Developer of the Original Code is Martijn Kooij a.k.a. Captain Caveman.

Alternatively, the contents of this file may be used under the terms of
either the GNU General Public License Version 2 or later (the "GPL"), or
the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
in which case the provisions of the GPL or the LGPL are applicable instead
of those above. If you wish to allow use of your version of this file only
under the terms of either the GPL or the LGPL, and not to allow others to
use your version of this file under the terms of the MPL, indicate your
decision by deleting the provisions above and replace them with the notice
and other provisions required by the GPL or the LGPL. If you do not delete
the provisions above, a recipient may use your version of this file under
the terms of any one of the MPL, the GPL or the LGPL.

***** END LICENSE BLOCK ***** */

const QLS_ALL_LOCALES = "af-ZA#am-ET#ar-AE#ar-BH#ar-DZ#ar-EG#ar-IQ#ar-JO#ar-KW#ar-LB#ar-LY#ar-MA#ar-OM#ar-QA#ar-SA#ar-SY#ar-TN#ar-YE#arn-CL#as-IN#ast-ES#az-AZ-Cyrl#az-AZ-Latn#ba-RU#be-BY#ber-DZ#bg-BG#bn-BD#bn-IN#bo-BT#bo-CN#br-FR#bs-BA-Cyrl#bs-BA-Latn#ca-AD#ca-ES#ca-FR#co-FR#cs-CZ#cy-GB#da-DK#de-AT#de-CH#de-DE#de-LI#de-LU#div-MV#el-GR#en-AU#en-BZ#en-CA#en-CB#en-GB#en-IE#en-IN#en-JA#en-MY#en-NZ#en-PH#en-SG#en-TT#en-US#en-ZA#en-ZW#eo-EO#es-AR#es-BO#es-CL#es-CO#es-CU#es-CR#es-DO#es-EC#es-ES#es-ES-ts#es-GT#es-HN#es-MX#es-NI#es-PA#es-PE#es-PR#es-PY#es-SV#es-UY#es-US#es-VE#et-EE#eu-ES#fa-IR#fi-FI#fil-PH#fo-FO#fr-BE#fr-CA#fr-CH#fr-FR#fr-LU#fr-MC#fur-IT#fy-NL#ga-IE#gbz-AF#gl-ES#gsw-FR#gu-IN#ha-NG-Latn#he-IL#hi-IN#hr-BA#hr-HR#hu-HU#hy-AM#id-ID#ii-CN#is-IS#it-CH#it-IT#iu-CA-Cans#iu-CA-Latn#ja-JP#ja-JP-mac#ka-GE#kk-KZ#kl-GL#km-KH#kn-IN#kok-IN#ko-KR#ky-KG#lb-LU#lo-LA#lt-LT#lv-LV#mi-NZ#mk-MK#ml-IN#mn-CN#mn-MN#moh-CA#mr-IN#ms-BN#ms-MY#mt-MT#nb-NO#ne-NP#nl-BE#nl-NL#nn-NO#ns-ZA#oc-FR#or-IN#pa-IN#pl-PL#ps-AF#pt-BR#pt-PT#qut-GT#quz-BO#quz-EC#quz-PE#rm-CH#ro-RO#ru-RU#rw-RW#sah-RU#sa-IN#se-FI#se-NO#se-SE#si-LK#sk-SK#sl-SI#sma-NO#sma-SE#smj-NO#smj-SE#smn-FI#sms-FI#sq-AL#sr-BA-Cyrl#sr-BA-Latn#sr-ME#sr-RS#sv-FI#sv-SE#sw-KE#syr-SY#ta-IN#ta-LK#te-IN#tg-TJ-Cyrl#th-TH#tk-TM#tn-ZA#ur-IN#tr-TR#tt-RU#ug-CN#uk-UA#ur-PK#uz-UZ-Cyrl#uz-UZ-Latn#vi-VN#wa-BE#wee-DE#wen-DE#wo-SN#xh-ZA#yo-NG#zh-CHS#zh-CHT#zh-CN#zh-HK#zh-MO#zh-SG#zh-TW#zu-ZA";
const QLS_DEFAULT_LOCALES = "en-US#nl-NL#fr-FR#it-IT#es-ES#ja-JP#de-DE#pt-PT#zh-CN#ru-RU#zh-TW";

addEventListener("load",QLSPreInit,true);
addEventListener("unload",QLSDeInit,false);

function QLSPreInit()
{
	if (!this.oQLSPref && !this.bQLSInitializing)
	{
		this.bQLSInitializing = true;
		setTimeout('QLSInit();', 500);
	}
}

function QLSInit()
{
	if (!this.QLSIsInitialized)
	{
		this.QLSPrefObserver = 
		{
			observe: function(subject, topic, prefName)
			{
				if (topic == "nsPref:changed" && prefName == "general.useragent.locale")
				{
					if (typeof(CheckLocale) == 'function') CheckLocale();
				}
			}
		};
		this.QLSSettingsObserver =
		{
			observe: function(subject, topic, state)
			{
				if (topic == "qls-settings" && state == 'OK' && typeof(ApplySettings) == "function") ApplySettings();
			}
		}

		var oPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
		oPrefService.addObserver("general.useragent.locale", this.QLSPrefObserver, false);
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
		oObService.addObserver(this.QLSSettingsObserver, "qls-settings", false); 

		this.oPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("general.useragent.");
		this.oQLSPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.qls.");
		this.oALPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("intl.");
		this.oSCPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("spellchecker.");
		
		if (!this.oQLSPref.prefHasUserValue("notifyrestart")) this.oQLSPref.setBoolPref("notifyrestart", true);
		if (!this.oQLSPref.prefHasUserValue("askautorestart")) this.oQLSPref.setBoolPref("askautorestart", true);

		if (!this.oQLSPref.prefHasUserValue('locale')) SetQLSPref("locale", GetLocale());

		if (!this.oQLSPref.prefHasUserValue('customlocale1')) SetQLSPref("customlocale1", "");
		if (!this.oQLSPref.prefHasUserValue('customlabel1')) SetQLSPref("customlabel1", "");
		if (!this.oQLSPref.prefHasUserValue('customlocale2')) SetQLSPref("customlocale2", "");
		if (!this.oQLSPref.prefHasUserValue('customlabel2')) SetQLSPref("customlabel2", "");
		if (!this.oQLSPref.prefHasUserValue('customlocale3')) SetQLSPref("customlocale3", "");
		if (!this.oQLSPref.prefHasUserValue('customlabel3')) SetQLSPref("customlabel3", "");

		if (!this.oQLSPref.prefHasUserValue('visiblemenuitems')) SetQLSPref("visiblemenuitems", QLS_DEFAULT_LOCALES);

		if (!this.oQLSPref.prefHasUserValue('switch_gulocale')) SetQLSPrefBool("switch_gulocale", true);
		if (!this.oQLSPref.prefHasUserValue('switch_accept_languages')) SetQLSPrefBool("switch_accept_languages", true);
		if (!this.oQLSPref.prefHasUserValue('switch_dictionary')) SetQLSPrefBool("switch_dictionary", true);
		if (!this.oQLSPref.prefHasUserValue('hide_tools')) SetQLSPrefBool("hide_tools", false);
		if (!this.oQLSPref.prefHasUserValue('hide_statusbar')) SetQLSPrefBool("hide_statusbar", false);

		if (!this.oQLSPref.prefHasUserValue('useautoswitch'))
		{
			var bUseAuto = true;
			if (GetQLSPrefBool("switch_gulocale")) bUseAuto = false;
			SetQLSPrefBool("useautoswitch", bUseAuto);
		}
		if (!this.oQLSPref.prefHasUserValue('autoswitchhosts')) SetQLSPref("autoswitchhosts", "");
		if (!this.oQLSPref.prefHasUserValue('fallbacklocale')) SetQLSPref("fallbacklocale", GetQLSPref("locale"));

		if (!this.oQLSPref.prefHasUserValue('switch_alwaysask')) SetQLSPrefBool("switch_alwaysask", false);
		if (!this.oQLSPref.prefHasUserValue('statusbarmode')) SetQLSPref("statusbarmode", "full");
		if (!this.oQLSPref.prefHasUserValue('autoswitchfortld')) SetQLSPrefBool("autoswitchfortld", false);

		if (!this.oQLSPref.prefHasUserValue('backup_acceptlanguages')) SetQLSPref("backup_acceptlanguages", "");

		if (!this.oQLSPref.prefHasUserValue('reloadbrowserafterhalswitch')) SetQLSPrefBool("reloadbrowserafterhalswitch", false);
		if (!this.oQLSPref.prefHasUserValue('switch_contentlocale')) SetQLSPrefBool("switch_contentlocale", GetQLSPrefBool("switch_dictionary"));
		if (!this.oQLSPref.prefHasUserValue('contentlocale')) SetQLSPref("contentlocale", GetQLSPref("locale"));
		if (!this.oQLSPref.prefHasUserValue('previouslocale')) SetQLSPref("previouslocale", GetQLSPref("locale"));
		if (!this.oQLSPref.prefHasUserValue('previouscontentlocale')) SetQLSPref("previouscontentlocale", GetQLSPref("locale"));

		this.oDefPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getDefaultBranch("general.useragent.");
		this.sDefaultLocale = GetDefaultLocale();
		if (!this.sDefaultLocale || this.sDefaultLocale == "") this.sDefaultLocale = "en-US";
		if (this.sDefaultLocale.indexOf("-") == -1) this.sDefaultLocale = CCodeToLocale(this.sDefaultLocale);

		var oBrowser = document.getElementById('content');
		if (oBrowser)
		{
			oBrowser.addEventListener("DOMContentLoaded", function() {QLSCheckContentLocale(false);}, true);
			var oTabs = oBrowser.tabContainer;
			if (!oTabs)
			{
				oTabs = oBrowser.mPanelContainer;
				oTabs.addEventListener("select", function() {QLSCheckContentLocale(true);}, false);
			}
			else
			{
				oTabs.addEventListener("TabSelect", function() {QLSCheckContentLocale(true);}, false);
			}
		}
	
		ApplySettings();
		InitDefault();
		CheckLocale();
		//QLSCheckUpdateURL(); Silently fixed by the Firefox team (without closing bug on bugzilla).
		
		this.QLSIsInitialized = true;
		this.bQLSDisableInstantApply = QLSGetInstantApply();
	}
	var oContent = document.getElementById('content-frame');
	if (oContent)
	{
		oContent.addEventListener("focus", QLSTBCheckAddressField, true);
	}
}

function QLSDeInit()
{
	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
	oObService.removeObserver(this.QLSSettingsObserver, "qls-settings"); 
	var oPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
	oPrefService.removeObserver("general.useragent.locale", this.QLSPrefObserver);

	this.QLSPrefObserver = null;
	this.QLSSettingsObserver = null;
}

function QLSCheckUpdateURL()
{
	//Since the automatic update checker checks for updates based on the current locale, it will not find any updates if you have switched to a locale that is not available as translation (or it might even download a "wrong" version).
	//In here we do what is also done in nsUpdateService.js, replacing the %LOCALE% param of the update url, but this time we do it with the default locale, so the locale Firefox/TB was installed in.
	var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch2);
	var sURL = "";
	
	if (!oPrefs.prefHasUserValue('app.update.url.override'))
	{
	    var oDefPrefs = oPrefs.QueryInterface(Components.interfaces.nsIPrefService).getDefaultBranch(null);
		try {sURL = oDefPrefs.getCharPref('app.update.url');}
		catch (e) {}
		oPrefs.setCharPref('app.update.url.override', sURL);
	}
	
	try {sURL = oPrefs.getCharPref('app.update.url.override');}
	catch (e) {}

	if (sURL && sURL != "" && sURL.indexOf("%LOCALE%") >= 0)
	{
		sURL = sURL.replace(/%LOCALE%/g, this.sDefaultLocale);
		oPrefs.setCharPref('app.update.url.override', sURL);
	}	
}

function InitDefault()
{
	if (document.getElementById('taskPopup')) InitDefaultSeamonkey();
	var oMItem;
	var sLabel;

	oMItem = document.getElementById("defaultQLS");
	if (oMItem)
	{
		sLabel = oMItem.getAttribute('statustext') + " (" + this.sDefaultLocale +  ")";

		oMItem.setAttribute("label", sLabel);
		oMItem.setAttribute("ccode", this.sDefaultLocale);
	}
	oMItem = document.getElementById("tbdefaultQLS");
	if (oMItem)
	{
		sLabel = oMItem.getAttribute('statustext') + " (" + this.sDefaultLocale +  ")";

		oMItem.setAttribute("label", sLabel);
		oMItem.setAttribute("ccode", this.sDefaultLocale);
	}
	oMItem = document.getElementById("sbpdefaultQLS");
	if (oMItem)
	{
		sLabel = oMItem.getAttribute('statustext') + " (" + this.sDefaultLocale +  ")";

		oMItem.setAttribute("label", sLabel);
		oMItem.setAttribute("ccode", this.sDefaultLocale);
	}
}

function CheckLocale()
{
	//Uncheck all.
	UnCheckLocale();
	
	var oElements;
	var iIndex, iLen;

	//Check ui locale
	var sLocale = GetQLSPref("locale");

	var oElement = document.getElementById(sLocale);
	var oTBElement = document.getElementById('tb_' + sLocale);
	var oSBPElement = document.getElementById('sbp_' + sLocale);
	if (!oElement)
	{
		oElements = document.getElementsByAttribute('ccode', sLocale.toLowerCase());
		iLen = oElements.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (oElements[iIndex].nodeName == "menuitem")
			{
				if (oElements[iIndex].id.indexOf('sbp') >= 0) oSBPElement = oElements[iIndex];
				else if (oElements[iIndex].id.indexOf('tb') >= 0) oTBElement = oElements[iIndex];
				else oElement = oElements[iIndex];
			}
		}
	}
	if (!oElement)
	{
		sLocale = GetSeamonkeyLocale()
		oElement = document.getElementById(sLocale);
		oSBPElement = document.getElementById('sbp_' + sLocale);
		
		if (!oElement) oElement = document.getElementsByAttribute('ccode', sLocale.toLowerCase())[0];
	}
	if (oElement)
	{
		oElement.setAttribute("hidden", false);
		oElement.setAttribute("ui_checked", 'true');
	}
	if (oTBElement)
	{
		oTBElement.setAttribute("hidden", false);
		oTBElement.setAttribute("ui_checked", 'true');
	}
	if (oSBPElement)
	{
		oSBPElement.setAttribute("hidden", false);
		oSBPElement.setAttribute("ui_checked", 'true');
	}

	//Check content locale
	var sCLocale = GetQLSPref("contentlocale");
	oElement = document.getElementById(sCLocale);
	oTBElement = document.getElementById('tb_' + sCLocale);
	oSBPElement = document.getElementById('sbp_' + sCLocale);
	if (!oElement)
	{
		oElements = document.getElementsByAttribute('ccode', sCLocale.toLowerCase());
		iIndex, iLen = oElements.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (oElements[iIndex].nodeName == "menuitem")
			{
				if (oElements[iIndex].id.indexOf('sbp') >= 0) oSBPElement = oElements[iIndex];
				else if (oElements[iIndex].id.indexOf('tb') >= 0) oTBElement = oElements[iIndex];
				else oElement = oElements[iIndex];
			}
		}
	}
	if (!oElement)
	{
		sCLocale = GetSeamonkeyLocale()
		oElement = document.getElementById(sCLocale);
		oSBPElement = document.getElementById('sbp_' + sCLocale);
		
		if (!oElement) oElement = document.getElementsByAttribute('ccode', sCLocale.toLowerCase())[0];
	}
	if (oElement)
	{
		oElement.setAttribute("hidden", false);
		oElement.setAttribute("content_checked", 'true');
	}
	if (oTBElement)
	{
		oTBElement.setAttribute("hidden", false);
		oTBElement.setAttribute("content_checked", 'true');
	}
	if (oSBPElement)
	{
		oSBPElement.setAttribute("hidden", false);
		oSBPElement.setAttribute("content_checked", 'true');
	}

	if (document.getElementById("defaultQLS")) document.getElementById("defaultQLS").setAttribute('disabled', (sLocale == this.sDefaultLocale || sCLocale == this.sDefaultLocale));
	if (document.getElementById("tbdefaultQLS")) document.getElementById("tbdefaultQLS").setAttribute('disabled', (sLocale == this.sDefaultLocale || sCLocale == this.sDefaultLocale));
	if (document.getElementById("sbpdefaultQLS")) document.getElementById("sbpdefaultQLS").setAttribute('disabled', (sLocale == this.sDefaultLocale || sCLocale == this.sDefaultLocale));
	QLSInitStatusBar(sLocale, sCLocale);
}

function UnCheckLocale()
{
	var oElements;
	var iIndex, iLen;

	oElements = document.getElementsByAttribute('content_checked', 'true');
	iLen = oElements.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (!oElements[iIndex]) return UnCheckLocale();
		oElements[iIndex].setAttribute('content_checked', 'false');
	}
	oElements = document.getElementsByAttribute('ui_checked', 'true');
	iLen = oElements.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (!oElements[iIndex]) return UnCheckLocale();
		oElements[iIndex].setAttribute('ui_checked', 'false');
	}
}

function ChangeLocaleBack()
{
    var sLocale = GetQLSPref("previouslocale");
    if (GetQLSPrefBool("switch_contentlocale")) sLocale = GetQLSPref("previouscontentlocale");
    
    ChangeLocale(sLocale);
}

function ChangeLocale(sLocale)
{
	var bChangeLocale = true;
	sLocale = sLocale.replace('tb_', '');
	sLocale = sLocale.replace('sbp_', '');
	//if (GetQLSPref("locale") == sLocale && GetQLSPref("contentlocale") == sLocale) return;

	if (GetQLSPrefBool("switch_alwaysask"))
	{
		var oSettings = {gulocale: GetQLSPrefBool("switch_gulocale"), contentlocale: GetQLSPrefBool("switch_contentlocale"), alwaysask: GetQLSPrefBool("switch_alwaysask"), accepted: false};
		openDialog("chrome://qls/content/qlsaskswitchsettings.xul", "qls-askswitchsettings", "modal,center", oSettings);
		if (oSettings.accepted)
		{
			SetQLSPrefBool("switch_gulocale", oSettings.gulocale);
			SetQLSPrefBool("switch_contentlocale", oSettings.contentlocale);
			SetQLSPrefBool("switch_alwaysask", oSettings.alwaysask);
		}
		else
		{
			bChangeLocale = false;
			CheckLocale();
		}
	}
	
	if (bChangeLocale)
	{
		if (GetQLSPrefBool("switch_contentlocale"))
		{
            SetQLSPref("previouscontentlocale", GetQLSPref("contentlocale"));
			SetQLSPref("contentlocale", sLocale);
            if (GetQLSPrefBool("switch_accept_languages"))
            {
                UpdateAcceptLanguages(sLocale, GetQLSPrefBool("reloadbrowserafterhalswitch"));
            }
			SwitchSpellCheckerDictionary(sLocale);
		}
		
		if (GetQLSPrefBool("switch_gulocale"))
		{
            SetQLSPref("previouslocale", GetQLSPref("locale"));
			SetQLSPref("locale", sLocale);
			SetLocale(sLocale);
			SetQLSPref("fallbacklocale", sLocale);
		
			if (document.getElementById('taskPopup')) ChangeLocaleSeamonkey(sLocale);
			DoLocaleWorkAround();
		}

		if (GetQLSPrefBool("useautoswitch") && GetQLSPrefBool("switch_contentlocale"))
		{
			QLSAddHostLocale(sLocale);
		}
		CheckLocale();
	}
	//Alert other windows.
	var oWindowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var oWindowManagerInterface = oWindowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var oWindows = oWindowManagerInterface.getEnumerator("navigator:browser");
	var oWindow;
	while (oWindows.hasMoreElements())
	{
		oWindow = oWindows.getNext();
		if (typeof(oWindow.CheckLocale) == "function") oWindow.CheckLocale();
	}
}

function QLSChangeContentAndDictionaryLocale(sLocale, bDontReloadBrowser)
{
	if (GetQLSPrefBool("switch_contentlocale"))
	{
		var bReloadBrowser = !bDontReloadBrowser && GetQLSPrefBool("reloadbrowserafterhalswitch");
        if (GetQLSPrefBool("switch_accept_languages"))
        {
            UpdateAcceptLanguages(sLocale, bReloadBrowser);
        }
		setTimeout('SwitchSpellCheckerDictionary("' + sLocale + '");', 250);
	}
}

function QLSCheckContentLocale(bDontReloadBrowser)
{
	if (GetQLSPrefBool("useautoswitch") && !document.getElementById("addressCol2#1") && !document.getElementById("calendar-content-box"))
	{
		QLSInitHostLocales();
		var sFallbackLocale = GetQLSPref("fallbacklocale");
		var sHost = QLSGetHost(content.location.href);
		var sLocale = "";
		var iIndex, iLen = window.QLSHostToLocale.length;

		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (window.QLSHostToLocale[iIndex][0] == sHost) sLocale = window.QLSHostToLocale[iIndex][1];
		}
		if (sLocale == "")
		{
			if (typeof(gBrowser) == "object")
			{
				var oDocument;
				try {gBrowser.selectedBrowser}
				catch (e) {getBrowser();}
				oDocument = gBrowser.selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document.documentElement;
				if (oDocument)
				{
					sLocale = oDocument.getAttribute("lang");
					if (!sLocale || sLocale == "") sLocale = oDocument.getAttribute("xml:lang");
				}
				if (sLocale && sLocale != "" && sLocale.indexOf('-') == -1) sLocale = CCodeToLocale(sLocale);
			}
		}
		if ((!sLocale || sLocale == "") && GetQLSPrefBool("autoswitchfortld"))
		{
			//Check the current Top Level Domain.
			var sTLD = sHost.substr(sHost.lastIndexOf(".") + 1);
			if (sTLD != "")
			{
				sLocale = QLSTLDToLocale(sTLD);
			}
		}

		if (!sLocale || sLocale == "") sLocale = sFallbackLocale;
		
		sLocale = sLocale.replace('tb_', '');
		sLocale = sLocale.replace('sbp_', '');
		if (GetQLSPref("contentlocale") != sLocale)
		{
			UnCheckLocale();
    		SetQLSPref("contentlocale", sLocale);
			CheckLocale();
    		QLSChangeContentAndDictionaryLocale(sLocale, bDontReloadBrowser);
		}
	}
}

function QLSTBCheckAddressField(oField)
{
	if (typeof(awGetInputElement) == "function") oField = awGetInputElement(1);
	if (!oField) oField = document.getElementById("addressCol2#1");
	if (oField)
	{
		var sValue = QLSGetEmailAddress(oField.value);
		if (sValue && sValue != "")
		{
			QLSCheckTBContentLocale(sValue);
		}
	}
}

function QLSGetEmailAddress(sValue)
{
	if (sValue && sValue != "")
	{
		var iPos1 = sValue.indexOf("<");
		var iPos2 = sValue.indexOf(">");
		if (iPos1 >= 0 && iPos2 >= 0) sValue = sValue.substring(iPos1 + 1, iPos2); //Get the e-mail address.
	}
	return sValue;
}

function QLSCheckTBContentLocale(sEmailAddress)
{
	if (GetQLSPrefBool("useautoswitch") && document.getElementById("addressCol2#1"))
	{
		QLSInitHostLocales();
		var sFallbackLocale = GetQLSPref("fallbacklocale");
		var sLocale = "";
		var iIndex, iLen = window.QLSHostToLocale.length;

		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (window.QLSHostToLocale[iIndex][0] == sEmailAddress) sLocale = window.QLSHostToLocale[iIndex][1];
		}

		if ((!sLocale || sLocale == "") && GetQLSPrefBool("autoswitchfortld"))
		{
			//Check the current Top Level Domain.
			var sTLD = sEmailAddress.substr(sEmailAddress.lastIndexOf(".") + 1);
			if (sTLD != "")
			{
				sLocale = QLSTLDToLocale(sTLD);
			}
		}

		if (!sLocale || sLocale == "") sLocale = sFallbackLocale;
		
		sLocale = sLocale.replace('tb_', '');
		sLocale = sLocale.replace('sbp_', '');
		if (GetQLSPref("contentlocale") != sLocale)
		{
            /*For TB there's no need to switch if it's not avaiable...*/
            var aMItems = GetQLSPref("visiblemenuitems").split("#");
            var iIndex, iLen = aMItems.length;
            var bFound = false;
            for (iIndex = 0; iIndex < iLen; iIndex ++)
            {
                if (sLocale.indexOf(aMItems[iIndex]) >= 0 || aMItems[iIndex].indexOf(sLocale) >= 0) bFound = true;
            }
            
            if (bFound)
            {
    			UnCheckLocale();
        		SetQLSPref("contentlocale", sLocale);
    			CheckLocale();
        		QLSChangeContentAndDictionaryLocale(sLocale, false);
            }
		}
	}
}

function QLSAddHostLocale(sLocale)
{
	QLSInitHostLocales();
	var oField = document.getElementById("addressCol2#1");
	var sHost = QLSGetHost(content.location.href);
	var iIndex;

	if (oField)
	{
		for (iIndex = 1; iIndex < 30; iIndex ++)
		{
			oField = document.getElementById("addressCol2#" + iIndex);
			if (oField)
			{
				sHost = QLSGetEmailAddress(oField.value);
			    QLSAddHostLocaleCheckAndStore(sLocale, sHost);
			}
		}
	}
	else QLSAddHostLocaleCheckAndStore(sLocale, sHost);
}

function QLSAddHostLocaleCheckAndStore(sLocale, sHost)
{
	var iIndex, iLen = window.QLSHostToLocale.length;
	var bFound = false;

	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (window.QLSHostToLocale[iIndex][0] == sHost)
		{
			window.QLSHostToLocale[iIndex][1] = sLocale;
			bFound = true;
		}
	}
	if (!bFound)
	{
		window.QLSHostToLocale[iLen] = new Array();
		window.QLSHostToLocale[iLen][0] = sHost;
		window.QLSHostToLocale[iLen][1] = sLocale;
	}
	QLSStoreHostLocalePref();
	QLSInitHostLocales(true);
}

function QLSStoreHostLocalePref()
{
	var aTemp = new Array();
	var sHostLocale = "";
	var iIndex, iLen = window.QLSHostToLocale.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		aTemp[iIndex] = window.QLSHostToLocale[iIndex].join(';');
	}
	sHostLocale = aTemp.join(' ');
	SetQLSPref("autoswitchhosts", sHostLocale);
}

function QLSInitHostLocales(bForceReCreate)
{
	if (bForceReCreate || !window.QLSHostToLocale)
	{
		window.QLSHostToLocale = null;
		window.QLSHostToLocale = new Array();
		
		var aTmp = GetQLSPref("autoswitchhosts").split(' ');
		var iIndex, iLen = aTmp.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			window.QLSHostToLocale[iIndex] = aTmp[iIndex].split(';');
		}
	}
}

function QLSInitStatusBar(sSelectedLocale, sSelectedCLocale)
{
	var oSBPanel, oSBTooltip;
	var sTooltip, sCTooltip;
	
	oSBPanel = document.getElementById('statusbar-QLS');
	oSBTooltip = document.getElementById('statusbar-tooltip-QLS-locale');
	oSBCTooltip = document.getElementById('statusbar-tooltip-QLS-contentlocale');

	if (oSBPanel && oSBTooltip && oSBCTooltip)
	{
		var sDisplayLocale = sSelectedCLocale;
		if (!sDisplayLocale || sDisplayLocale == "") sDisplayLocale = "en-US";
		if (sDisplayLocale.indexOf("-") == -1) sDisplayLocale = CCodeToLocale(sDisplayLocale);
		oSBPanel.setAttribute('ccode', sDisplayLocale);
		if (oSBPanel.getAttribute('mode') != GetQLSPref("statusbarmode"))
		{
			oSBPanel.setAttribute('mode', "text");
			//The timeout is necessary because Ff sometimes renders the icon/text in a diffent order (text first/icon first)
			setTimeout('SetStatusBarMode();', 1);
		}
		oSBPanel.childNodes[0].value = sDisplayLocale;
		
		var oElement = document.getElementById(sSelectedLocale);
		if (!oElement) oElement = document.getElementsByAttribute('ccode', sSelectedLocale.toLowerCase())[0];
		if (!oElement)
		{
			sSelectedLocale = GetSeamonkeyLocale()
			oElement = document.getElementById(sSelectedLocale);
			if (!oElement) oElement = document.getElementsByAttribute('ccode', sSelectedLocale.toLowerCase())[0];
		}
		var oCElement = document.getElementById(sSelectedCLocale);
		if (!oCElement) oCElement = document.getElementsByAttribute('ccode', sSelectedCLocale.toLowerCase())[0];
		if (!oCElement)
		{
			sSelectedCLocale = GetSeamonkeyLocale()
			oCElement = document.getElementById(sSelectedCLocale);
			if (!oCElement) oCElement = document.getElementsByAttribute('ccode', sSelectedCLocale.toLowerCase())[0];
		}
		if (oElement && oCElement)
		{
			sTooltip = document.getElementById('statusbar-tooltip-QLS-locale').getAttribute('localizedpart');
			sCTooltip = document.getElementById('statusbar-tooltip-QLS-contentlocale').getAttribute('localizedpart');
			sTooltip = sTooltip.replace(/%1/, oElement.getAttribute('label'));
			sCTooltip = sCTooltip.replace(/%1/, oCElement.getAttribute('label'));
			oSBTooltip.setAttribute('value', sTooltip);
			oSBCTooltip.setAttribute('value', sCTooltip);
		}
	}
}

function SetStatusBarMode()
{
	var oSBPanel = document.getElementById('statusbar-QLS');
	if (oSBPanel) oSBPanel.setAttribute('mode', GetQLSPref("statusbarmode"));
}

function DoLocaleWorkAround()
{
	//Showing about:config seems to solve the problem of not being able to change non-installed locale (often) in Ff 1.0.7 and 1.4
	window.open("chrome://qls/content/qlsreloadchrome.xul", "qlspleasewait", "chrome,close,titlebar,modal,centerscreen"); 
	var oPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var checkResult = {};

	try
	{
		//Auto restart in Ff 1.4 and later.
		var oAppStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(Components.interfaces.nsIAppStartup);
		if (!oAppStartup.eRestart) throw("Restart is not supported in Seamonkey...");
		var bAskRestart = this.oQLSPref.getBoolPref("askautorestart");
		if (bAskRestart == true)
		{
			var sTitle = document.getElementById("mCavemanQLS").getAttribute('label');
			var sMsg = document.getElementById("msCavemanQLS2").getAttribute('statustext');
			var sNotify = document.getElementById("msCavemanQLS").getAttribute('statustext');

			var bRestart = oPromptService.confirmCheck(window,sTitle, sMsg, sNotify, checkResult);

			if (checkResult.value) this.oQLSPref.setBoolPref("askautorestart", false);
		}
		if (bRestart == true || bAskRestart == false)
		{
			if (typeof canQuitApplication == "function" && canQuitApplication())
			{
				var oRPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.sessionstore.");
				oRPref.setBoolPref("resume_session_once", true);
				oAppStartup.quit(oAppStartup.eAttemptQuit | oAppStartup.eRestart);
			}
		}
	}
	catch (e)
	{
		var bNotify = this.oQLSPref.getBoolPref("notifyrestart")
	
		if (bNotify == true)
		{
			//Show message in other versions.
			if (document.getElementById("mCavemanQLS") && document.getElementById("mpCavemanQLS"))
			{
				var sTitle = document.getElementById("mCavemanQLS").getAttribute('label');
				var sMsg = document.getElementById("mpCavemanQLS").getAttribute('statustext');
				var sNotify = document.getElementById("msCavemanQLS").getAttribute('statustext');

				oPromptService.alertCheck(window, sTitle, sMsg, sNotify, checkResult);
				if (checkResult.value) this.oQLSPref.setBoolPref("notifyrestart", false);
			}
		}
	}
}

function ChangeLocaleSeamonkey(sLocale)
{
	var QLS_InProfile = true;
	
	var oRDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	try {var oDS = oRDF.GetDataSourceBlocking("rdf:chrome");}
	catch (e) {return;}

	var inProfile = oDS.GetTarget(oRDF.GetResource("urn:mozilla:package:qls"), oRDF.GetResource("http://www.mozilla.org/rdf/chrome#locType"), true);
	if (inProfile instanceof Components.interfaces.nsIRDFLiteral && inProfile.Value == "install") QLS_InProfile = false;
	
	try
	{
		var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
		if (!("selectLocaleForPackage" in chromeRegistry)) chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIChromeRegistrySea);
		chromeRegistry.selectLocaleForPackage(sLocale, "qls", QLS_InProfile);
	}
	catch (e) {return;}
}

function InitDefaultSeamonkey()
{
	if (this.sDefaultLocale.length > 10)
	{
		var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
		this.sDefaultLocale = chromeRegistry.getSelectedLocale("global");

		if (("selectLocaleForPackage" in chromeRegistry))
		{
			var QLS_InProfile = true;
			var oRDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
			try {var oDS = oRDF.GetDataSourceBlocking("rdf:chrome");}
			catch (e) {return;}

			var inProfile = oDS.GetTarget(oRDF.GetResource("urn:mozilla:package:mozgest"), oRDF.GetResource("http://www.mozilla.org/rdf/chrome#locType"), true);
			if (inProfile instanceof Components.interfaces.nsIRDFLiteral && inProfile.Value == "install") QLS_InProfile = false;
			var QLSLocale = chromeRegistry.getSelectedLocale("qls");
			chromeRegistry.selectLocaleForPackage(QLSLocale, "qls", QLS_InProfile);	
		}		
	}
}

function OpenSettings()
{
	if (this.bQLSDisableInstantApply) QLSEnableInstantApply(false);
	var bSupportsPrefWindow = false;
	try
	{
		document.getElementById("test_noprefwindow").preferences;
		if (typeof(document.getElementById("test_noprefwindow").preferences) == "undefined") bSupportsPrefWindow = false;
		else bSupportsPrefWindow = true;
	}
	catch (e) {bSupportsPrefWindow = false;}
	if (bSupportsPrefWindow)
	{
		window.openDialog("chrome://qls/content/qlssettings.xul", "qls-settings", "chrome,titlebar,toolbar,centerscreen,modal,resizable");
	}
	else
	{
		window.openDialog("chrome://qls/content/qlssettings_noprefwindow.xul", "qls-settings", "chrome,titlebar,toolbar,centerscreen,modal,resizable");
	}
}

function ApplySettings()
{
	var oParent;
	var oMItem, oTBMItem, oSBPItem;
	var sLabel = "", sLocale = "";
	var bShowSep = false;
	
	oMItem = document.getElementById("qlscustom1");
	oTBMItem = document.getElementById("tbqlscustom1");
	oSBPItem = document.getElementById("sbpqlscustom1");
	sLocale = GetQLSPref("customlocale1");
	sLabel = GetQLSPref("customlabel1");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
		if (oSBPItem)
		{
			oSBPItem.setAttribute("hidden", false);
			oSBPItem.setAttribute("clocale", sLocale);
			oSBPItem.setAttribute("ccode", sLocale.toLowerCase());
			oSBPItem.setAttribute("label", sLabel);
		}
	}
	oMItem = document.getElementById("qlscustom2");
	oTBMItem = document.getElementById("tbqlscustom2");
	oSBPMItem = document.getElementById("sbpqlscustom2");
	sLocale = GetQLSPref("customlocale2");
	sLabel = GetQLSPref("customlabel2");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
		if (oSBPMItem)
		{
			oSBPMItem.setAttribute("hidden", false);
			oSBPMItem.setAttribute("clocale", sLocale);
			oSBPMItem.setAttribute("ccode", sLocale.toLowerCase());
			oSBPMItem.setAttribute("label", sLabel);
		}
	}
	oMItem = document.getElementById("qlscustom3");
	oTBMItem = document.getElementById("tbqlscustom3");
	oSBPMItem = document.getElementById("sbpqlscustom3");
	sLocale = GetQLSPref("customlocale3");
	sLabel = GetQLSPref("customlabel3");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
		if (oSBPMItem)
		{
			oSBPMItem.setAttribute("hidden", false);
			oSBPMItem.setAttribute("clocale", sLocale);
			oSBPMItem.setAttribute("ccode", sLocale.toLowerCase());
			oSBPMItem.setAttribute("label", sLabel);
		}
	}
	
	if (bShowSep == true)
	{
		if (document.getElementById("msCavemanQLS2")) document.getElementById("msCavemanQLS2").setAttribute("hidden", false);
		if (document.getElementById("tbmsCavemanQLS2")) document.getElementById("tbmsCavemanQLS2").setAttribute("hidden", false);
		if (document.getElementById("sbpmsCavemanQLS2")) document.getElementById("sbpmsCavemanQLS2").setAttribute("hidden", false);
	}
	
	var aAllMItems = QLS_ALL_LOCALES.split("#");
	var aMItems = GetQLSPref("visiblemenuitems").split("#");
	var iIndex, iLen;
	
	iLen = aAllMItems.length;

	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oMItem = document.getElementById(aAllMItems[iIndex]);
        if (oMItem) oMItem.setAttribute("hidden", true);
		oTBMItem = document.getElementById('tb_' + aAllMItems[iIndex]);
        if (oTBMItem) oTBMItem.setAttribute("hidden", true);
		oSBPMItem = document.getElementById('sbp_' + aAllMItems[iIndex]);
        if (oSBPMItem) oSBPMItem.setAttribute("hidden", true);
    }
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oMItem = document.getElementById(aAllMItems[iIndex]);
		if (oMItem && (oMItem.getAttribute("ui_checked") == 'true' || oMItem.getAttribute("content_checked") == 'true')) oMItem.setAttribute("hidden", false);
		oTBMItem = document.getElementById('tb_' + aAllMItems[iIndex]);
		if (oTBMItem && (oTBMItem.getAttribute("ui_checked") == 'true' || oTBMItem.getAttribute("content_checked") == 'true')) oTBMItem.setAttribute("hidden", false);
		oSBPMItem = document.getElementById('sbp_' + aAllMItems[iIndex]);
		if (oSBPMItem && (oSBPMItem.getAttribute("ui_checked") == 'true' || oSBPMItem.getAttribute("content_checked") == 'true')) oSBPMItem.setAttribute("hidden", false);
	}
	iLen = aMItems.length;
	for (iIndex = iLen -1; iIndex > -1; iIndex --)
	{
		oMItem = document.getElementById(aMItems[iIndex]);
		if (oMItem)
		{
			oParent = oMItem.parentNode;
			oParent.removeChild(oMItem);
			oMItem.setAttribute("hidden", false);
			oParent.insertBefore(oMItem, oParent.childNodes[6]);
		}
		oTBMItem = document.getElementById('tb_' + aMItems[iIndex]);
		if (oTBMItem)
		{
			oParent = oTBMItem.parentNode;
			oParent.removeChild(oTBMItem);
			oTBMItem.setAttribute("hidden", false);
			oParent.insertBefore(oTBMItem, oParent.childNodes[6]);
		}
		oSBPMItem = document.getElementById('sbp_' + aMItems[iIndex]);
		if (oSBPMItem)
		{
			oParent = oSBPMItem.parentNode;
			oParent.removeChild(oSBPMItem);
			oSBPMItem.setAttribute("hidden", false);
			oParent.insertBefore(oSBPMItem, oParent.childNodes[6]);
		}
	}

	var oSItem = document.getElementById("statusbar-QLS");
	var oMItem = document.getElementById("mCavemanQLS");
	if (GetQLSPrefBool("hide_statusbar") && oSItem) oSItem.setAttribute("hidden", true);
	else if (oSItem) oSItem.setAttribute("hidden", false);
	if (GetQLSPrefBool("hide_tools") && oMItem) oMItem.setAttribute("hidden", true);
	else if (oMItem) oMItem.setAttribute("hidden", false);
	
	QLSInitHostLocales(true);
	setTimeout("QLSTBCheckAddressField();", 500);
	QLSInitStatusBar(GetLocale(), GetSpellCheckerDictionary());
	if (this.bQLSDisableInstantApply) QLSEnableInstantApply(true);
	QLSCheckContentLocale(false);
}

function GetLocale()
{
	try {return this.oPref.getComplexValue("locale", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oPref.getCharPref("locale");
}

function GetDefaultLocale()
{
	try {return this.oDefPref.getComplexValue("locale", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oDefPref.getCharPref("locale");
}

function GetSeamonkeyLocale()
{
	var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
	return chromeRegistry.getSelectedLocale("qls");
}

function SetLocale(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oPref.setComplexValue("locale", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function UpdateAcceptLanguages(sData, bReloadBrowser)
{
	var sAL = GetAcceptLanguages();
	var aAL = sAL.split(',');
	var sSearch = sData;
	var iIndex = ArrayIndexOf(aAL, sSearch);
	sSearch = GetCCode(sSearch);
	if (iIndex == -1) iIndex = ArrayIndexOf(aAL, sSearch);

	//Remove lang code from the accept languages.
	while (iIndex >= 0)
	{	
		aAL.splice(iIndex, 1);
		iIndex = ArrayIndexOf(aAL, sSearch);
		if (iIndex == -1)
		{
			sSearch = GetCCode(sSearch);
			iIndex = ArrayIndexOf(aAL, sSearch);
		}
	}
	//Add it at the beginning again, most detailed must come first.
	if (sData.length > sSearch)
	{
		aAL.unshift(sData);
		if (sSearch!= sData) aAL.unshift(sSearch);
	}
	else
	{
		aAL.unshift(sSearch);
		if (sData != sSearch) aAL.unshift(sData);
	}
	sAL = aAL.join(',');

	SetAcceptLanguages(sAL);
	
	if (bReloadBrowser)
	{
		BrowserReload();
	}
}

function SwitchSpellCheckerDictionary(sData)
{
	try
	{
		var oSC;
		try {oSC = Components.classes['@mozilla.org/spellchecker/engine;1'].getService(Components.interfaces.mozISpellCheckingEngine);}
		catch (e) {oSC = Components.classes['@mozilla.org/spellchecker/myspell;1'].getService(Components.interfaces.mozISpellCheckingEngine);}

		var aDictionaries  = {};
		var aCount = {};
		var aLocales;
		var iIndex, iLen;

		oSC.getDictionaryList(aDictionaries, aCount);

		aLocales = aDictionaries.value;
		iIndex = ArrayIndexOf(aLocales, sData)
		if (iIndex == -1)
		{
			//Long lang code does not exist, try short one.
			sData = GetCCode(sData);
			iIndex = ArrayIndexOf(aLocales, sData);
		}
		if (iIndex >= 0)
		{
			//Only set if the locale is available cause it will break spell checking if you set a not installed dict.
			oSC.dictionary = sData;
			SetSpellCheckerDictionary(sData);
		}

		var oEditor = QLSGetEditorForNode(document.commandDispatcher.focusedElement || document.commandDispatcher.focusedWindow);

        if (typeof(InlineSpellCheckerUI) == "object")
        {
    		InlineSpellCheckerUI.clearSuggestionsFromMenu();
    		InlineSpellCheckerUI.clearDictionaryListFromMenu();
        }
        
		try
		{
			if (oEditor)
			{
                if (typeof(InlineSpellCheckerUI) == "object")
                {
				    InlineSpellCheckerUI.init(oEditor);
				    InlineSpellCheckerUI.mInlineSpellChecker.spellCheckRange(null);
                }
                else
                {
                    oSpellChecker = oEditor.getInlineSpellChecker ? oEditor.getInlineSpellChecker(true) : oEditor.inlineSpellChecker;
                    if (oSpellChecker && oSpellChecker.spellChecker)
                    {
                        if (iIndex >= 0) oSpellChecker.spellChecker.SetCurrentDictionary(sData);
                        oSpellChecker.spellCheckRange(null);
                    }
                }
			}
		}
		catch (e) {}
        
		//gmail special...
        if (typeof(getBrowser) == "function")
        {
            if (getBrowser().contentDocument.getElementById("canvas_frame"))
            {
		        var oDocument = getBrowser().contentDocument.getElementById("canvas_frame").contentDocument;
		        if (oDocument)
		        {
			        var oElements = oDocument.getElementsByTagName('iframe');
			        iLen = oElements.length;
			        for (iIndex = 0; iIndex < iLen; iIndex ++)
			        {
				        if (oElements[iIndex].className && oElements[iIndex].className.indexOf("editable") >= 0 && oElements[iIndex].contentWindow)
				        {
					        oWindow = oElements[iIndex].contentWindow;
					        var oESession = oWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIEditingSession);
					        if (oESession.windowIsEditable(oWindow))
					        {
						        oEditor = oESession.getEditorForWindow(oWindow);
					        }
					        if (oEditor)
					        {
						        InlineSpellCheckerUI.init(oEditor);
						        InlineSpellCheckerUI.mInlineSpellChecker.spellCheckRange(null);
					        }
				        }
			        }
                }
		    }
        }
	}
	catch (e) {}
}

function QLSGetEditorForNode(oNode)
{
    if (oNode instanceof HTMLHtmlElement) oNode = oNode.ownerDocument.defaultView;
    if (oNode instanceof Window)
    {
      var oSession = oNode.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIEditingSession);
      if (oSession.windowIsEditable(oNode)) return oSession.getEditorForWindow(oNode);
    }
    else if (!oNode.readOnly) return oNode.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor;
    return null;
}

function GetAcceptLanguages(bForceGetCurrentValue)
{
	var sResult = GetQLSPref("backup_acceptlanguages", "");
	if ((!sResult || sResult == "") || bForceGetCurrentValue)
	{
		try {sResult = this.oALPref.getComplexValue("accept_languages", Components.interfaces.nsIPrefLocalizedString).data;}
		catch (e) {sResult = "";}
		sResult = this.oALPref.getCharPref("accept_languages");
	}
	SetQLSPref("backup_acceptlanguages", sResult);
	return sResult;
}

function SetAcceptLanguages(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oALPref.setComplexValue("accept_languages", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetSpellCheckerDictionary()
{
	var sResult = "";
	if (this.oSCPref.prefHasUserValue("dictionary"))
	{
		try {sResult = this.oSCPref.getComplexValue("dictionary", Components.interfaces.nsIPrefLocalizedString).data;}
		catch (e)
		{
			sResult = this.oSCPref.getCharPref("dictionary");
			if (sResult == "") sResult = this.sDefaultLocale;
		}
	}
	else {sResult = this.sDefaultLocale;}
	return sResult;
}

function SetSpellCheckerDictionary(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oSCPref.setComplexValue("dictionary", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetQLSPref(sName)
{
	try {return this.oQLSPref.getComplexValue(sName, Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oQLSPref.getCharPref(sName);
}

function SetQLSPref(sName, sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oQLSPref.setComplexValue(sName, Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetQLSPrefBool(sName)
{
	return this.oQLSPref.getBoolPref(sName);
}

function SetQLSPrefBool(sName, bData)
{
	this.oQLSPref.setBoolPref(sName, bData);
}

function ArrayIndexOf(a, s)
{
	var iIndex = -1, iLen = a.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++) if (a[iIndex] == s) return iIndex;
	return -1;
}

function GetCCode(sData)
{
	var iIndex = sData.search('-');
	if (iIndex >= 0) return sData.substring(0, iIndex);
	return sData;
}

function CCodeToLocale(sData)
{
	var sLocale = "";
	var oElement = document.getElementsByAttribute('ccode', sData)[0];
	if (oElement) sLocale = oElement.getAttribute('id');
	sLocale = sLocale.replace('tb_', '');
	sLocale = sLocale.replace('sbp_', '');
	return sLocale;
}

function QLSTLDToLocale(sData)
{
	if (!this.aQLSTLDToLocales) QLSInitTLDToLocales();
	
	sData = sData.toLowerCase();
	var iIndex, iLen = this.aQLSTLDToLocales.length;
	
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (sData == this.aQLSTLDToLocales[iIndex][0]) return this.aQLSTLDToLocales[iIndex][1];
	}
	return "";
}

function QLSGetHost(sURI)
{
	var sHost = sURI;
	
	try
	{
		var oIOS = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
   		var oURI = oIOS.newURI(sURI,null,null);
		oURI.spec = sURI;
		sHost = oURI.host;
	} catch (e) {}

	return sHost;
}

function QLSEnableInstantApply(bEnable)
{
	var oPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.preferences.");
	oPref.setBoolPref("instantApply", bEnable)
}

function QLSGetInstantApply()
{
	try
	{
		var oPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.preferences.");
		return oPref.getBoolPref("instantApply");
	}
	catch (e) {return false;}
}

function QLSWriteDebugMessage(aMsg)
{
    var oConsole = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces["nsIConsoleService"]);
    oConsole.logStringMessage("QLS Debug Message: " + aMsg);
}

function QLSInitTLDToLocales()
{
	this.aQLSTLDToLocales = null;
	this.aQLSTLDToLocales = new Array();
	this.aQLSTLDToLocales[0] = new Array('za', 'af-ZA');
	this.aQLSTLDToLocales[1] = new Array('et', 'am-ET');
	this.aQLSTLDToLocales[2] = new Array('ae', 'ar-AE');
	this.aQLSTLDToLocales[3] = new Array('bh', 'ar-BH');
	this.aQLSTLDToLocales[4] = new Array('', 'ar-DZ');
	this.aQLSTLDToLocales[5] = new Array('eg', 'ar-EG');
	this.aQLSTLDToLocales[6] = new Array('iq', 'ar-IQ');
	this.aQLSTLDToLocales[7] = new Array('jo', 'ar-JO');
	this.aQLSTLDToLocales[8] = new Array('kw', 'ar-KW');
	this.aQLSTLDToLocales[9] = new Array('lb', 'ar-LB');
	this.aQLSTLDToLocales[10] = new Array('ly', 'ar-LY');
	this.aQLSTLDToLocales[11] = new Array('ma', 'ar-MA');
	this.aQLSTLDToLocales[12] = new Array('om', 'ar-OM');
	this.aQLSTLDToLocales[13] = new Array('qa', 'ar-QA');
	this.aQLSTLDToLocales[14] = new Array('sa', 'ar-SA');
	this.aQLSTLDToLocales[15] = new Array('', 'ar-SY');
	this.aQLSTLDToLocales[16] = new Array('tn', 'ar-TN');
	this.aQLSTLDToLocales[17] = new Array('ye', 'ar-YE');
	this.aQLSTLDToLocales[18] = new Array('', 'arn-CL');
	this.aQLSTLDToLocales[19] = new Array('', 'as-IN');
	this.aQLSTLDToLocales[20] = new Array('', 'ast-ES');
	this.aQLSTLDToLocales[21] = new Array('az', 'az-AZ-Cyrl');
	this.aQLSTLDToLocales[22] = new Array('', 'az-AZ-Latn');
	this.aQLSTLDToLocales[23] = new Array('', 'ba-RU');
	this.aQLSTLDToLocales[24] = new Array('by', 'be-BY');
	this.aQLSTLDToLocales[25] = new Array('dz', 'ber-DZ');
	this.aQLSTLDToLocales[26] = new Array('bg', 'bg-BG');
	this.aQLSTLDToLocales[27] = new Array('', 'bn-IN');
	this.aQLSTLDToLocales[28] = new Array('bt', 'bo-BT');
	this.aQLSTLDToLocales[29] = new Array('', 'bo-CN');
	this.aQLSTLDToLocales[30] = new Array('', 'br-FR');
	this.aQLSTLDToLocales[31] = new Array('ba', 'bs-BA-Cyrl');
	this.aQLSTLDToLocales[32] = new Array('', 'bs-BA-Latn');
	this.aQLSTLDToLocales[33] = new Array('ad', 'ca-AD');
	this.aQLSTLDToLocales[34] = new Array('', 'ca-ES');
	this.aQLSTLDToLocales[35] = new Array('', 'ca-FR');
	this.aQLSTLDToLocales[36] = new Array('', 'co-FR');
	this.aQLSTLDToLocales[37] = new Array('cz', 'cs-CZ');
	this.aQLSTLDToLocales[38] = new Array('cym', 'cy-GB');
	this.aQLSTLDToLocales[39] = new Array('dk', 'da-DK');
	this.aQLSTLDToLocales[40] = new Array('at', 'de-AT');
	this.aQLSTLDToLocales[41] = new Array('ch', 'de-CH');
	this.aQLSTLDToLocales[42] = new Array('de', 'de-DE');
	this.aQLSTLDToLocales[43] = new Array('li', 'de-LI');
	this.aQLSTLDToLocales[44] = new Array('', 'de-LU');
	this.aQLSTLDToLocales[45] = new Array('mv', 'div-MV');
	this.aQLSTLDToLocales[46] = new Array('gr', 'el-GR');
	this.aQLSTLDToLocales[47] = new Array('au', 'en-AU');
	this.aQLSTLDToLocales[48] = new Array('bz', 'en-BZ');
	this.aQLSTLDToLocales[49] = new Array('ca', 'en-CA');
	this.aQLSTLDToLocales[50] = new Array('cb', 'en-CB');
	this.aQLSTLDToLocales[51] = new Array('uk', 'en-GB');
	this.aQLSTLDToLocales[52] = new Array('ie', 'en-IE');
	this.aQLSTLDToLocales[53] = new Array('', 'en-IN');
	this.aQLSTLDToLocales[54] = new Array('ja', 'en-JA');
	this.aQLSTLDToLocales[55] = new Array('', 'en-MY');
	this.aQLSTLDToLocales[56] = new Array('nz', 'en-NZ');
	this.aQLSTLDToLocales[57] = new Array('', 'en-PH');
	this.aQLSTLDToLocales[58] = new Array('', 'en-SG');
	this.aQLSTLDToLocales[59] = new Array('tt', 'en-TT');
	this.aQLSTLDToLocales[60] = new Array('us', 'en-US');
	this.aQLSTLDToLocales[61] = new Array('', 'en-ZA');
	this.aQLSTLDToLocales[62] = new Array('zw', 'en-ZW');
	this.aQLSTLDToLocales[63] = new Array('ar', 'es-AR');
	this.aQLSTLDToLocales[64] = new Array('bo', 'es-BO');
	this.aQLSTLDToLocales[65] = new Array('cl', 'es-CL');
	this.aQLSTLDToLocales[66] = new Array('co', 'es-CO');
	this.aQLSTLDToLocales[67] = new Array('cr', 'es-CR');
	this.aQLSTLDToLocales[68] = new Array('do', 'es-DO');
	this.aQLSTLDToLocales[69] = new Array('ec', 'es-EC');
	this.aQLSTLDToLocales[70] = new Array('es', 'es-ES');
	this.aQLSTLDToLocales[71] = new Array('', 'es-ES-ts');
	this.aQLSTLDToLocales[72] = new Array('gt', 'es-GT');
	this.aQLSTLDToLocales[73] = new Array('hn', 'es-HN');
	this.aQLSTLDToLocales[74] = new Array('mx', 'es-MX');
	this.aQLSTLDToLocales[75] = new Array('ni', 'es-NI');
	this.aQLSTLDToLocales[76] = new Array('pa', 'es-PA');
	this.aQLSTLDToLocales[77] = new Array('pe', 'es-PE');
	this.aQLSTLDToLocales[78] = new Array('pr', 'es-PR');
	this.aQLSTLDToLocales[79] = new Array('py', 'es-PY');
	this.aQLSTLDToLocales[80] = new Array('sv', 'es-SV');
	this.aQLSTLDToLocales[81] = new Array('uy', 'es-UY');
	this.aQLSTLDToLocales[82] = new Array('', 'es-US');
	this.aQLSTLDToLocales[83] = new Array('ve', 'es-VE');
	this.aQLSTLDToLocales[84] = new Array('ee', 'et-EE');
	this.aQLSTLDToLocales[85] = new Array('', 'eu-ES');
	this.aQLSTLDToLocales[86] = new Array('ir', 'fa-IR');
	this.aQLSTLDToLocales[87] = new Array('fi', 'fi-FI');
	this.aQLSTLDToLocales[88] = new Array('ph', 'fil-PH');
	this.aQLSTLDToLocales[89] = new Array('fo', 'fo-FO');
	this.aQLSTLDToLocales[90] = new Array('', 'fr-BE');
	this.aQLSTLDToLocales[91] = new Array('', 'fr-CA');
	this.aQLSTLDToLocales[92] = new Array('', 'fr-CH');
	this.aQLSTLDToLocales[93] = new Array('fr', 'fr-FR');
	this.aQLSTLDToLocales[94] = new Array('', 'fr-LU');
	this.aQLSTLDToLocales[95] = new Array('mc', 'fr-MC');
	this.aQLSTLDToLocales[96] = new Array('', 'fur-IT');
	this.aQLSTLDToLocales[97] = new Array('', 'fy-NL');
	this.aQLSTLDToLocales[98] = new Array('', 'ga-IE');
	this.aQLSTLDToLocales[99] = new Array('af', 'gbz-AF');
	this.aQLSTLDToLocales[100] = new Array('', 'gl-ES');
	this.aQLSTLDToLocales[101] = new Array('', 'gsw-FR');
	this.aQLSTLDToLocales[102] = new Array('', 'gu-IN');
	this.aQLSTLDToLocales[103] = new Array('ng', 'ha-NG-Latn');
	this.aQLSTLDToLocales[104] = new Array('il', 'he-IL');
	this.aQLSTLDToLocales[105] = new Array('in', 'hi-IN');
	this.aQLSTLDToLocales[106] = new Array('', 'hr-BA');
	this.aQLSTLDToLocales[107] = new Array('hr', 'hr-HR');
	this.aQLSTLDToLocales[108] = new Array('hu', 'hu-HU');
	this.aQLSTLDToLocales[109] = new Array('am', 'hy-AM');
	this.aQLSTLDToLocales[110] = new Array('id', 'id-ID');
	this.aQLSTLDToLocales[111] = new Array('', 'ii-CN');
	this.aQLSTLDToLocales[112] = new Array('is', 'is-IS');
	this.aQLSTLDToLocales[113] = new Array('', 'it-CH');
	this.aQLSTLDToLocales[114] = new Array('it', 'it-IT');
	this.aQLSTLDToLocales[115] = new Array('', 'iu-CA-Cans');
	this.aQLSTLDToLocales[116] = new Array('', 'iu-CA-Latn');
	this.aQLSTLDToLocales[117] = new Array('jp', 'ja-JP');
	this.aQLSTLDToLocales[118] = new Array('', 'ja-JP-mac');
	this.aQLSTLDToLocales[119] = new Array('ge', 'ka-GE');
	this.aQLSTLDToLocales[120] = new Array('kz', 'kk-KZ');
	this.aQLSTLDToLocales[121] = new Array('gl', 'kl-GL');
	this.aQLSTLDToLocales[122] = new Array('kh', 'km-KH');
	this.aQLSTLDToLocales[123] = new Array('', 'kn-IN');
	this.aQLSTLDToLocales[124] = new Array('', 'kok-IN');
	this.aQLSTLDToLocales[125] = new Array('kr', 'ko-KR');
	this.aQLSTLDToLocales[126] = new Array('kg', 'ky-KG');
	this.aQLSTLDToLocales[127] = new Array('lu', 'lb-LU');
	this.aQLSTLDToLocales[128] = new Array('la', 'lo-LA');
	this.aQLSTLDToLocales[129] = new Array('lt', 'lt-LT');
	this.aQLSTLDToLocales[130] = new Array('lv', 'lv-LV');
	this.aQLSTLDToLocales[131] = new Array('', 'mi-NZ');
	this.aQLSTLDToLocales[132] = new Array('mk', 'mk-MK');
	this.aQLSTLDToLocales[133] = new Array('', 'ml-IN');
	this.aQLSTLDToLocales[134] = new Array('', 'mn-CN');
	this.aQLSTLDToLocales[135] = new Array('mn', 'mn-MN');
	this.aQLSTLDToLocales[136] = new Array('', 'moh-CA');
	this.aQLSTLDToLocales[137] = new Array('', 'mr-IN');
	this.aQLSTLDToLocales[138] = new Array('bn', 'ms-BN');
	this.aQLSTLDToLocales[139] = new Array('my', 'ms-MY');
	this.aQLSTLDToLocales[140] = new Array('mt', 'mt-MT');
	this.aQLSTLDToLocales[141] = new Array('no', 'nb-NO');
	this.aQLSTLDToLocales[142] = new Array('np', 'ne-NP');
	this.aQLSTLDToLocales[143] = new Array('be', 'nl-BE');
	this.aQLSTLDToLocales[144] = new Array('nl', 'nl-NL');
	this.aQLSTLDToLocales[145] = new Array('', 'nn-NO');
	this.aQLSTLDToLocales[146] = new Array('', 'ns-ZA');
	this.aQLSTLDToLocales[147] = new Array('', 'oc-FR');
	this.aQLSTLDToLocales[148] = new Array('', 'or-IN');
	this.aQLSTLDToLocales[149] = new Array('', 'pa-IN');
	this.aQLSTLDToLocales[150] = new Array('pl', 'pl-PL');
	this.aQLSTLDToLocales[151] = new Array('', 'ps-AF');
	this.aQLSTLDToLocales[152] = new Array('br', 'pt-BR');
	this.aQLSTLDToLocales[153] = new Array('pt', 'pt-PT');
	this.aQLSTLDToLocales[154] = new Array('', 'qut-GT');
	this.aQLSTLDToLocales[155] = new Array('', 'quz-BO');
	this.aQLSTLDToLocales[156] = new Array('', 'quz-EC');
	this.aQLSTLDToLocales[157] = new Array('', 'quz-PE');
	this.aQLSTLDToLocales[158] = new Array('', 'rm-CH');
	this.aQLSTLDToLocales[159] = new Array('ro', 'ro-RO');
	this.aQLSTLDToLocales[160] = new Array('ru', 'ru-RU');
	this.aQLSTLDToLocales[161] = new Array('rw', 'rw-RW');
	this.aQLSTLDToLocales[162] = new Array('', 'sah-RU');
	this.aQLSTLDToLocales[163] = new Array('', 'sa-IN');
	this.aQLSTLDToLocales[164] = new Array('', 'se-FI');
	this.aQLSTLDToLocales[165] = new Array('', 'se-NO');
	this.aQLSTLDToLocales[166] = new Array('se', 'se-SE');
	this.aQLSTLDToLocales[167] = new Array('lk', 'si-LK');
	this.aQLSTLDToLocales[168] = new Array('sk', 'sk-SK');
	this.aQLSTLDToLocales[169] = new Array('si', 'sl-SI');
	this.aQLSTLDToLocales[170] = new Array('', 'sma-NO');
	this.aQLSTLDToLocales[171] = new Array('', 'sma-SE');
	this.aQLSTLDToLocales[172] = new Array('', 'smj-NO');
	this.aQLSTLDToLocales[173] = new Array('', 'smj-SE');
	this.aQLSTLDToLocales[174] = new Array('', 'smn-FI');
	this.aQLSTLDToLocales[175] = new Array('', 'sms-FI');
	this.aQLSTLDToLocales[176] = new Array('al', 'sq-AL');
	this.aQLSTLDToLocales[177] = new Array('', 'sr-BA-Cyrl');
	this.aQLSTLDToLocales[178] = new Array('', 'sr-BA-Latn');
	this.aQLSTLDToLocales[179] = new Array('', 'sr-ME');
	this.aQLSTLDToLocales[180] = new Array('', 'sr-RS');
	this.aQLSTLDToLocales[181] = new Array('', 'sv-FI');
	this.aQLSTLDToLocales[182] = new Array('', 'sv-SE');
	this.aQLSTLDToLocales[183] = new Array('ke', 'sw-KE');
	this.aQLSTLDToLocales[184] = new Array('sy', 'syr-SY');
	this.aQLSTLDToLocales[185] = new Array('', 'ta-IN');
	this.aQLSTLDToLocales[185] = new Array('', 'ta-LK');
	this.aQLSTLDToLocales[186] = new Array('', 'te-IN');
	this.aQLSTLDToLocales[187] = new Array('tj', 'tg-TJ-Cyrl');
	this.aQLSTLDToLocales[188] = new Array('th', 'th-TH');
	this.aQLSTLDToLocales[189] = new Array('tm', 'tk-TM');
	this.aQLSTLDToLocales[190] = new Array('', 'tn-ZA');
	this.aQLSTLDToLocales[191] = new Array('ur', 'ur-IN');
	this.aQLSTLDToLocales[192] = new Array('tr', 'tr-TR');
	this.aQLSTLDToLocales[193] = new Array('', 'tt-RU');
	this.aQLSTLDToLocales[194] = new Array('', 'ug-CN');
	this.aQLSTLDToLocales[195] = new Array('ua', 'uk-UA');
	this.aQLSTLDToLocales[196] = new Array('pk', 'ur-PK');
	this.aQLSTLDToLocales[197] = new Array('uz', 'uz-UZ-Cyrl');
	this.aQLSTLDToLocales[198] = new Array('', 'uz-UZ-Latn');
	this.aQLSTLDToLocales[199] = new Array('vn', 'vi-VN');
	this.aQLSTLDToLocales[200] = new Array('', 'wee-DE');
	this.aQLSTLDToLocales[201] = new Array('', 'wen-DE');
	this.aQLSTLDToLocales[202] = new Array('sn', 'wo-SN');
	this.aQLSTLDToLocales[203] = new Array('', 'xh-ZA');
	this.aQLSTLDToLocales[204] = new Array('', 'yo-NG');
	this.aQLSTLDToLocales[205] = new Array('chs', 'zh-CHS');
	this.aQLSTLDToLocales[206] = new Array('cht', 'zh-CHT');
	this.aQLSTLDToLocales[207] = new Array('cn', 'zh-CN');
	this.aQLSTLDToLocales[208] = new Array('hk', 'zh-HK');
	this.aQLSTLDToLocales[209] = new Array('mo', 'zh-MO');
	this.aQLSTLDToLocales[210] = new Array('sg', 'zh-SG');
	this.aQLSTLDToLocales[211] = new Array('tw', 'zh-TW');
	this.aQLSTLDToLocales[212] = new Array('', 'zu-ZA');
	this.aQLSTLDToLocales[213] = new Array('eo', 'eo-EO');
	this.aQLSTLDToLocales[214] = new Array('', 'wa-BE');
	this.aQLSTLDToLocales[215] = new Array('bd', 'bn-BD');
	this.aQLSTLDToLocales[216] = new Array('', 'es-CU');
}
